/*
Script responsible for message-passing between the legacy extension
and embedded webextension, for data migration purposes.
*/

(function() {
// Lazily give UserScriptRegistry some time to load.
setTimeout(() => {
  let haveScripts = {};
  onListUserScripts({'includeDisabled': true}, null, userScripts => {
    for (let userScript of userScripts) {
      haveScripts[userScript.uuid] = userScript.version || 0;
    }

    var port = browser.runtime.connect();
    port.onMessage.addListener(message => {
      // from bg/on-message.js
      onMessage(message, null, () => {});
    });
    browser.runtime.sendMessage(
        {'name': 'MigrateGreasemonkeyUserScripts', 'have': haveScripts});
  });
}, 2000);
})();


function onMigrateUserScript(msg, sender, sendResponse) {
  let scriptDetail = msg.script;
  scriptDetail.parsedDetails = parseUserScript(
      scriptDetail.content, scriptDetail.downloadUrl, false);

  let userScript = new EditableUserScript(scriptDetail);
  userScript.calculateEvalContent();
  UserScriptRegistry.saveUserScript(userScript);
}
